searchNodes=[{"doc":"Implementation of an Ueberauth Strategy for &quot;Sign In with Apple&quot;. Configuration This provider supports the following configuration: Callback URL : (Required) The URI to which the authorization redirects. It must include a domain name and can’t be an IP address or localhost. Apple will check the provided URL against the domains and redirect URIs configured in your Service ID. Defaults to [...]/auth/:provider/callback according to the configured provider name. Response mode : How response information will be sent back to the server during the callback phase.. Valid values are &quot;query&quot; , &quot;fragment&quot; , and &quot;form_post&quot; . If you requested any scopes, the value must be form_post . Defaults to &quot;query&quot; if no scopes are requested, &quot;form_post&quot; otherwise. Scopes : The amount of user information requested from Apple. Valid values are name and email , with multiple values separated by spaces. You can request one, both, or none. Defaults to no scopes ( &quot;&quot; ).","ref":"Ueberauth.Strategy.Apple.html","title":"Ueberauth.Strategy.Apple","type":"module"},{"doc":"Includes the credentials from the Apple response.","ref":"Ueberauth.Strategy.Apple.html#credentials/1","title":"Ueberauth.Strategy.Apple.credentials/1","type":"function"},{"doc":"Callback implementation for Ueberauth.Strategy.default_options/0 .","ref":"Ueberauth.Strategy.Apple.html#default_options/0","title":"Ueberauth.Strategy.Apple.default_options/0","type":"function"},{"doc":"Stores the raw information (including the token) obtained from the google callback.","ref":"Ueberauth.Strategy.Apple.html#extra/1","title":"Ueberauth.Strategy.Apple.extra/1","type":"function"},{"doc":"Handles the callback from Apple.","ref":"Ueberauth.Strategy.Apple.html#handle_callback!/1","title":"Ueberauth.Strategy.Apple.handle_callback!/1","type":"function"},{"doc":"Handles initial request for Apple authentication.","ref":"Ueberauth.Strategy.Apple.html#handle_request!/1","title":"Ueberauth.Strategy.Apple.handle_request!/1","type":"function"},{"doc":"Fetches the fields to populate the info section of the Ueberauth.Auth struct.","ref":"Ueberauth.Strategy.Apple.html#info/1","title":"Ueberauth.Strategy.Apple.info/1","type":"function"},{"doc":"Fetches the uid field from the response.","ref":"Ueberauth.Strategy.Apple.html#uid/1","title":"Ueberauth.Strategy.Apple.uid/1","type":"function"},{"doc":"OAuth2 for Apple. Add client_id and client_secret to your configuration: config :ueberauth, Ueberauth.Strategy.Apple.OAuth, client_id: System.get_env(&quot;APPLE_CLIENT_ID&quot;), client_secret: System.get_env(&quot;APPLE_CLIENT_SECRET&quot;)","ref":"Ueberauth.Strategy.Apple.OAuth.html","title":"Ueberauth.Strategy.Apple.OAuth","type":"module"},{"doc":"Provides the authorize url for the request phase of Ueberauth. No need to call this usually.","ref":"Ueberauth.Strategy.Apple.OAuth.html#authorize_url!/2","title":"Ueberauth.Strategy.Apple.OAuth.authorize_url!/2","type":"function"},{"doc":"Callback implementation for OAuth2.Strategy.authorize_url/2 .","ref":"Ueberauth.Strategy.Apple.OAuth.html#authorize_url/2","title":"Ueberauth.Strategy.Apple.OAuth.authorize_url/2","type":"function"},{"doc":"Construct a client for requests to Apple. This will be setup automatically for you in Ueberauth.Strategy.Apple . These options are only useful for usage outside the normal callback phase of Ueberauth.","ref":"Ueberauth.Strategy.Apple.OAuth.html#client/1","title":"Ueberauth.Strategy.Apple.OAuth.client/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Apple.OAuth.html#get/4","title":"Ueberauth.Strategy.Apple.OAuth.get/4","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Apple.OAuth.html#get_access_token/2","title":"Ueberauth.Strategy.Apple.OAuth.get_access_token/2","type":"function"},{"doc":"Callback implementation for OAuth2.Strategy.get_token/3 .","ref":"Ueberauth.Strategy.Apple.OAuth.html#get_token/3","title":"Ueberauth.Strategy.Apple.OAuth.get_token/3","type":"function"},{"doc":"Provides helpers for working with Apple-generated tokens. Apple provides a public list of keys that may be used for token signing at https://appleid.apple.com/auth/keys .","ref":"Ueberauth.Strategy.Apple.Token.html","title":"Ueberauth.Strategy.Apple.Token","type":"module"},{"doc":"Decode an ID Token provided by the Apple Auth API. Options :public_keys : {Module, :function, args} to call in order to get a list of public keys. The returned data must be in the form {:ok, keys} where keys is a list of maps matching the structure found at https://appleid.apple.com/auth/keys . Defaults to a function that uses HTTPoison to request the keys on every call.","ref":"Ueberauth.Strategy.Apple.Token.html#payload/2","title":"Ueberauth.Strategy.Apple.Token.payload/2","type":"function"},{"doc":"Public Key used by Apple to sign ID Tokens","ref":"Ueberauth.Strategy.Apple.Token.html#t:public_key/0","title":"Ueberauth.Strategy.Apple.Token.public_key/0","type":"type"},{"doc":"ID Token supplied by the Apple Auth API","ref":"Ueberauth.Strategy.Apple.Token.html#t:t/0","title":"Ueberauth.Strategy.Apple.Token.t/0","type":"type"},{"doc":"UeberauthApple is a convenience module related to the Apple strategy for Ueberauth. For more information, see the Overview .","ref":"UeberauthApple.html","title":"UeberauthApple","type":"module"},{"doc":"Generate a Client Secret from the given options. This function does not concern itself with caching. Because generation of the Client Secret can be costly on every request, it is recommended to wrap this function with a cache-aware function. Options :client_id : ( Required ) Reverse-domain Services ID configured for Sign In with Apple . :expires_in : Duration, in number of seconds, for the secret to be valid. Apple specifies a maximum duration of 15552000 seconds (6 months), which is the default. :key_id : ( Required ) Key ID for the Apple-generated Private Key associated with the Services ID given in :client_id . :private_key ( Required ) Full text of the Apple-generated Private Key file associated with the Services ID given in :client_id . :team_id : ( Required ) Apple Developer Program team ID, as found in the top-right of the Apple Developer Console. Examples Below is an example of a client secret generator that maintains an expiring cache of the secret. defmodule MyApp.Apple @expiration_sec 86400 * 180 @spec client_secret ( keyword ) :: String . t ( ) def client_secret ( _config \\\\ [ ] ) do with { :error , :not_found } &lt;- get_client_secret_from_cache ( ) do secret = UeberauthApple . generate_client_secret ( %{ client_id : Application . fetch_env! ( :my_app , :apple_client_id ) , expires_in : @expiration_sec , key_id : Application . fetch_env! ( :my_app , :apple_private_key_id ) , team_id : Application . fetch_env! ( :my_app , :apple_team_id ) , private_key : Application . fetch_env! ( :my_app , :apple_private_key ) } ) put_client_secret_in_cache ( secret , @expiration_sec ) secret end end end","ref":"UeberauthApple.html#generate_client_secret/1","title":"UeberauthApple.generate_client_secret/1","type":"function"},{"doc":"Ueberauth plugin for Apple OAuth / Sign In with Apple","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Ueberauth is an authentication framework for Elixir applications that specializes in OAuth . This library is one of many plugins (called Strategies) that allow Ueberauth to integrate with different identity providers. Specifically, this one implements an OAuth integration with Apple, for their Sign In with Apple service.","ref":"readme.html#what-is-this","title":"Overview - What is this?","type":"extras"},{"doc":"Apple's OAuth implementation is different than you may expect. Please keep the following in mind: There are only two scopes available, name and email , for retrieving personal information about the user signing in. Neither scope provides access to any API endpoints; instead they change the data returned during the sign-in process. If any scopes are requested during sign-in, the response from Apple must be in the form of a form POST request to your application. Otherwise, a GET request with query parameters will occur. Accepting POST callbacks require additional setup with Ueberauth that may not be necessary for other providers. Because scoped requests must use a form POST request, any cookies that will be read during the callback phase must have SameSite=None (and, therefore, Secure ). Otherwise the browser will block them from being sent along with the POST because it is not a top-level navigation. Apple requires a Primary App ID (with the Sign In with Apple capability enabled), Services ID , and Private Key to be set up in their Apple Developer Console before integration can occur. Apple OAuth Client Secrets are generated from a Private Key and have a maximum lifetime of six months. Users may choose not to share their information with your application, in which case an anonymized private relay email address will be supplied during the callback phase. Apple does not supply the user's name in callback responses after the first time.","ref":"readme.html#important-notes","title":"Overview - Important Notes","type":"extras"},{"doc":"For detailed instructions, see Getting Started . Set up a Services ID and download a Private Key in the Apple Developer Console . See Getting Started or the official documentation for more information Add :ueberauth_apple to your list of dependencies in mix.exs and run mix deps.get : def deps do [ # ... { :ueberauth , &quot;~&gt; 0.10&quot; } , { :ueberauth_apple , &quot;~&gt; 0.6.1&quot; } ] end Add this library as a new provider for Ueberauth (see Getting Started for more information on the available options): config :ueberauth , Ueberauth , providers : [ # Default configuration: does not retrieve name or email address during sign-in. apple : { Ueberauth.Strategy.Apple , [ ] } # Alternative configuration: retrieve name and email during sign-in. apple : { Ueberauth.Strategy.Apple , callback_methods : [ &quot;POST&quot; ] , default_scope : &quot;name email&quot; } ] Configure the provider (see Getting Started for more information on generating client secrets): config :ueberauth , Ueberauth.Strategy.Apple.OAuth , client_id : System . get_env ( &quot;APPLE_CLIENT_ID&quot; ) , client_secret : { MyApp.Apple , :client_secret } Create a Client Secret generator function. (Apple's Client Secrets are generated from a Private Key and have a maximum life of six months.) Integrate Ueberauth with the rest of your application (usually: router and controller). See Getting Started or the Ueberauth Example application.","ref":"readme.html#quick-start","title":"Overview - Quick Start","type":"extras"},{"doc":"Making a request to /auth/apple will redirect to the Apple sign-in page with the relevant query parameters. You can include a scope query param to configure the scopes at runtime: /auth/apple?scope=name%20email . The default scopes can also be configured in the provider definition. To guard against client-side request modification, it's important to still check the domain in info.urls[:website] within the Ueberauth.Auth struct if you want to limit sign-in to a specific domain.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Thank you to Loop Social for the original implementation of this library. Thank you to CodeSandbox for updates and maintenance of this library.","ref":"readme.html#acknowledgments","title":"Overview - Acknowledgments","type":"extras"},{"doc":"Please see LICENSE for licensing details.","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"Setting up your application to use Sign In with Apple requires a few steps: Create and configure a Services ID in the Apple Developer Console and download a private key. Install :ueberauth_apple (and :ueberauth , if not already installed). Configure Ueberauth to include this library as a provider. Configure this library, including a method of client secret generation. Let's get started!","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Note If you already have a Services ID with Sign In with Apple set up, skip down to Installation . You can also check out the official documentation for setting up Sign In with Apple . Abbreviated instructions are included below. Prerequisites You must have an Apple Developer account with Account Holder or Admin permissions. You must have an eligible domain to associate with your service (not localhost , .test , etc.). You must have a Primary App ID with Sign In with Apple enabled. (For this, go to Certificates, Identifiers &amp; Profiles and select the Identifiers tab ( direct link ). Then create or select your App ID, and enable the Sign In with Apple capability.) Services ID Services IDs establish a relationship between your website and your Apple Developer Program team and apps. You may choose to have multiple Services IDs for multiple instances of your application (e.g. staging and production). Each Services ID has a reverse-domain identifier, like com.example.my-app , that is distinct from your app IDs. You can enable one or more services on each Service ID; for our purposes, only &quot;Sign In with Apple&quot; is necessary. To set up a Services ID, perform the following: Log in to your Apple Developer account. Go to Certificates, Identifiers &amp; Profiles , select the Identifiers tab, and then select Services IDs from the dropdown in the top-right ( direct link ). Click + to create a new identifier. Select Services IDs and continue. Provide a description (example MyApp Staging ) and identifier (example com.example.my-app-staging ). Continue, and click Register . You should now see the new Services ID in the list of all identifiers. Click it again to configure it. Enable Sign In with Apple and click Configure . If you have a published application (such as an iOS version of your app) already, you likely want to use that app's identifier as the Primary App ID. Learn more about grouping App IDs here . Input all Domains and Subdomains that will act as origins for Sign In with Apple requests. Input the exact Return URL(s) your app will use during the OAuth flow. Usually these look like https://my-app.example.com/auth/apple/callback . Confirm your choices. Once back at the Services ID configuration page, Continue and Save . You now have a Services ID that is eligible to make requests to Sign In with Apple . Currently, it is also necessary to provide :ueberauth_apple with the details necessary to make an API request to Apple. This includes a private key. Private Key After creating a Services ID, we also need to create a private key for use with API requests. In the Apple Developer console, return to Certificates, Identifiers &amp; Profiles and select the Keys tab ( direct link ). Click + to create a new key. Provide a name for the key (example Sign In with Apple Staging ) and select Sign In with Apple . Click Configure for this service. Select the same Primary App ID that was used for your Services ID. Be aware that this private key will be eligible to make requests against any of the grouped IDs (so even a staging key should be considered a production-level secret). Save the Primary ID choice, Continue , and Register . Download the new Key file and record the Key ID. Both of these pieces of information are necessary to generate a client secret later. Important Private Key files are critical secrets for your application. Even if you intend to use a Key only for testing, it has access to Sign In with Apple for all Services IDs connected to the same Primary App ID. Use configuration best practices to provide these keys at runtime in the production environment.","ref":"getting-started.html#set-up-with-apple","title":"Getting Started - Set Up with Apple","type":"extras"},{"doc":"Now that you have a Services ID and Private Key set up with Apple, you can begin integrating Sign In with Apple in your application. Package Add ueberauth_apple as a dependency in mix.exs and run mix deps.get : def deps do [ # ... { :ueberauth , &quot;~&gt; 0.10&quot; } , { :ueberauth_apple , &quot;~&gt; 0.6.1&quot; } , ] end Provider Configuration Then add this library as a provider in your configuration for Ueberauth: config :ueberauth , Ueberauth , providers : [ apple : { Ueberauth.Strategy.Apple , [ ] } ] The following options are available here, in the provider definition: callback_methods : List of HTTP methods to accept during the callback phase. Should be [&quot;POST&quot;] if requesting any scopes ( name or email ), or [&quot;GET&quot;] otherwise. Defaults to [&quot;GET&quot;] . See also Ueberauth's documentation . callback_path : See Ueberauth's documentation . callback_url : URL to use as the Redirect URI parameter in the request phase. Defaults to a value based on the Phoenix Endpoint's host and the Ueberauth configuration. default_scope : Space-separated string of personal information to retrieve from Apple during sign-in. Available options are name and email . If any scopes are included, the callback_methods option must include &quot;POST&quot; . Defaults to no scopes, or &quot;&quot; . request_path : See Ueberauth's documentation . Plug Integration As with other Ueberauth providers, it is necessary to implement handlers for the callback phase. This usually includes adding Ueberauth as a plug in an authentication-related controller: defmodule MyAppWeb.AuthController do use MyAppWeb , :controller plug Ueberauth # ... end Then, implement handlers for success and failure cases during the callback phase: defmodule MyAppWeb.AuthController do # ... def callback ( %{ assigns : %{ ueberauth_failure : failure } } = conn , _params ) do message = Enum . map_join ( failure . errors , &quot;; &quot; , fn error -&gt; error . message end ) conn |&gt; put_flash ( :error , &quot;An error occurred during authentication: \#{ message } &quot; ) |&gt; redirect ( to : &quot;/&quot; ) end def callback ( %{ assigns : %{ ueberauth_auth : auth } } = conn , _params ) do case MyApp.Accounts . create_or_update_user ( auth ) do { :ok , user } -&gt; conn |&gt; put_flash ( :info , &quot;Successfully logged in&quot; ) |&gt; log_in_and_redirect_user ( user ) { :error , _changeset } -&gt; conn |&gt; put_flash ( :error , &quot;An error occurred while saving login&quot; ) |&gt; redirect ( to : &quot;/&quot; ) end end end Finally, ensure the relevant routes are available in the router: defmodule MyAppWeb.Router # ... scope &quot;/auth&quot; , UeberauthExampleWeb do pipe_through :browser get &quot;/:provider&quot; , AuthController , :request # Include this for requests with no scopes, or if you use other providers that require it. get &quot;/:provider/callback&quot; , AuthController , :callback # Include this for requests with any scopes (name and/or email). post &quot;/:provider/callback&quot; , AuthController , :callback end end For further assistance, check out the Ueberauth Example .","ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras"},{"doc":"In addition to the configuration provided above, this library accepts configuration for its OAuth module. config :ueberauth , Ueberauth.Strategy.Apple.OAuth , client_id : System . get_env ( &quot;APPLE_CLIENT_ID&quot; ) , client_secret : { MyApp.Apple , :client_secret } The following options are available: client_id : ( Required ) OAuth client ID used during both the request and callback phases. This matches the reverse-domain Services ID registered with Apple. client_secret : ( Required ) OAuth client secret OR a function used to generate this secret. Apple restricts client secrets to a maximum lifetime of six months, so most applications will generate and cache this secret at runtime. Use a string as the value to define the secret directly, or {Module, :function} as the value to define the generator function (see below). Generating the Client Secret See also the official documentation for more information. A typical client secret generator might look like this: defmodule MyApp.Apple @expiration_sec 86400 * 180 @spec client_secret ( keyword ) :: String . t ( ) def client_secret ( _config \\\\ [ ] ) do with { :error , :not_found } &lt;- get_client_secret_from_cache ( ) do secret = UeberauthApple . generate_client_secret ( %{ client_id : Application . fetch_env! ( :my_app , :apple_client_id ) , expires_in : @expiration_sec , key_id : Application . fetch_env! ( :my_app , :apple_private_key_id ) , team_id : Application . fetch_env! ( :my_app , :apple_team_id ) , private_key : Application . fetch_env! ( :my_app , :apple_private_key ) } ) put_client_secret_in_cache ( secret , @expiration_sec ) secret end end end In this example, the client_secret configuration for the OAuth module would be {MyApp.Apple, :client_secret} . The config argument supplied by this library includes basic information about the request, including the client ID if configured: [ strategy : Ueberauth.Strategy.Apple.OAuth , site : &quot;https://appleid.apple.com&quot; , authorize_url : &quot;/auth/authorize&quot; , token_url : &quot;/auth/token&quot; , redirect_uri : &quot;https://my-app.example.com/auth/apple/callback&quot; , client_id : &quot;com.example.my-app&quot; , client_secret : { MyApp.Apple , :client_secret } ] Because client secret generation may take some time, it is recommended to use a caching mechanism (ETS, Redis, etc.) to hold the generated secret until its expiration.","ref":"getting-started.html#oauth-configuration","title":"Getting Started - OAuth Configuration","type":"extras"},{"doc":"Hello there. Thank you for your interest in contributing to this project. Although the goals of this project are very simple, maintenance of any project takes effort. Reading and following the guidelines in this document is an act of kindness and respect for other contributors. With your help, we can address issues, make changes, and work together efficiently.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"There are many ways to contribute to this project: Users of the project can report issues and share new use-cases. Everyone can help improve documentation and support others in Discussions. Anyone can assist in the triage of bugs, identifying root causes, and proposing solutions. Please keep in mind the intended scope of this package: an Ueberauth strategy for integrating with Sign In with Apple .","ref":"contributing.html#ways-to-contribute","title":"Contributing - Ways to Contribute","type":"extras"},{"doc":"All contributions to this project must align with the code of conduct . Beyond that, we ask: Please be kind. Maintaining this project is not paid work. Please create an issue before embarking on major refactors or new features. Let's make a reasonable effort to support older versions of Elixir and OTP.","ref":"contributing.html#ground-rules","title":"Contributing - Ground Rules","type":"extras"},{"doc":"If you're interested in doing something specific, here are some guidelines: Security Issues If you find a security-related issue with this project, please refrain from opening a public issue and instead create a private security report . Bugs and Blockers Please use GitHub Issues to report reproducible bugs. Feature Requests and Ideas Please use GitHub Discussions to share requests and ideas for improvements to the library. Implementing Changes If you've decided to take on the implementation of a new feature or fix, please open an issue or create a discussion post first to get feedback.","ref":"contributing.html#workflows","title":"Contributing - Workflows","type":"extras"},{"doc":"For maintainers, the process of releasing this package to Hex.pm centers around git tags. To make a new release: Update the Changelog with a new header that has today's date and the new version. Include any missing notes from changes since the last release, and any additional upgrade instructions users may need. Update the @version number in mix.exs . The form should be X.Y.Z , with optional suffixes, but no leading v . Update the Quick Start installation instructions in README.md to have the newest non-suffixed version number. Update the Installation instructions in guides/getting-started.md to have the newest non-suffixed version number. Commit the above changes with a generic commit message, such as Release X.Y.Z . Tag the commit as X.Y.Z , with optional suffixes, but no leading v . Push the commits and tag (for example, git push origin main --tags ). Observe the GitHub Action titled Release . This action automatically publishes the package to Hex.pm.","ref":"contributing.html#releases","title":"Contributing - Releases","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2019 Loop Now Technologies, Inc. Copyright (c) 2022 CodeSandbox, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]